#line 1 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SerialFlashHelper.c"
#line 1 "d:/arm/projects/demo/serial_flash/3 libstock example/soft_uart_helper.h"



void Init_Soft_UART();
void Soft_UART_WriteText(char *string);
#line 1 "d:/arm/projects/demo/serial_flash/3 libstock example/serial_flash_util.h"




void SerialFlashUtilInit();



unsigned long CopyImageToSerialFlash(const code char *image, unsigned int image_length, char erase_chip);


char* FlashReadHandler(unsigned long offset, unsigned long count, unsigned long* num);
#line 1 "d:/arm/projects/demo/serial_flash/3 libstock example/sf_driver.h"
#line 33 "d:/arm/projects/demo/serial_flash/3 libstock example/sf_driver.h"
extern sbit CS_Serial_Flash_bit;
extern sbit CS_Serial_Flash_Direction_bit;



static const unsigned short _SERIAL_FLASH_CMD_RDID = 0x9F;
static const unsigned short _SERIAL_FLASH_CMD_READ = 0x03;
static const unsigned short _SERIAL_FLASH_CMD_WRITE = 0x02;
static const unsigned short _SERIAL_FLASH_CMD_WREN = 0x06;
static const unsigned short _SERIAL_FLASH_CMD_RDSR = 0x05;
static const unsigned short _SERIAL_FLASH_CMD_ERASE = 0xC7;
static const unsigned short _SERIAL_FLASH_CMD_EWSR = 0x06;
static const unsigned short _SERIAL_FLASH_CMD_WRSR = 0x01;
static const unsigned short _SERIAL_FLASH_CMD_SER = 0xD8;


void SerialFlash_init();
void SerialFlash_WriteEnable();
unsigned char SerialFlash_IsWriteBusy();
void SerialFlash_WriteByte(unsigned char _data, unsigned long address);
void SerialFlash_WriteWord(unsigned int _data, unsigned long address);
unsigned char SerialFlash_ReadID(void);
unsigned char SerialFlash_ReadByte(unsigned long address);
unsigned int SerialFlash_ReadWord(unsigned long address);
unsigned char SerialFlash_WriteArray(unsigned long address, unsigned char* pData, unsigned int nCount);
void SerialFlash_ReadArray(unsigned long address, unsigned char* pData, unsigned int nCount);
void SerialFlash_ChipErase(void);
void SerialFlash_ResetWriteProtection();
void SerialFlash_SectorErase(unsigned long address);
#line 1 "d:/arm/projects/demo/serial_flash/3 libstock example/colored_squares_resources.h"
const code char red_square_bmp[3206];
const code char green_square_bmp[3206];
const code char blue_square_bmp[3206];
const code char pink_square_bmp[3206];
#line 21 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SerialFlashHelper.c"
char TFT_DataPort at GPIO_PORTJ_DATA;
sbit TFT_RST at GPIO_PORTH_DATA.B5;
sbit TFT_BLED at GPIO_PORTA_DATA.B3;
sbit TFT_RS at GPIO_PORTG_DATA.B7;
sbit TFT_CS at GPIO_PORTH_DATA.B6;
sbit TFT_RD at GPIO_PORTC_DATA.B5;
sbit TFT_WR at GPIO_PORTH_DATA.B4;
char TFT_DataPort_Direction at GPIO_PORTJ_DIR;
sbit TFT_RST_Direction at GPIO_PORTH_DIR.B5;
sbit TFT_BLED_Direction at GPIO_PORTA_DIR.B3;
sbit TFT_RS_Direction at GPIO_PORTG_DIR.B7;
sbit TFT_CS_Direction at GPIO_PORTH_DIR.B6;
sbit TFT_RD_Direction at GPIO_PORTC_DIR.B5;
sbit TFT_WR_Direction at GPIO_PORTH_DIR.B4;


void InitMCU(){

 char status = 0;
 status = GPIO_Config(&GPIO_PORTC_DATA_BITS, _GPIO_PINMASK_7, _GPIO_DIR_OUTPUT, _GPIO_CFG_DIGITAL_ENABLE, 0);
 if (status == 1) Soft_UART_WriteText("GPIO error");
}

void main() {
 Init_Soft_UART();

 InitMCU();

 SPI0_Init_Advanced(10000000, _SPI_MASTER, _SPI_8_BIT, &_GPIO_MODULE_SPI0_A245);
 SerialFlash_init();
 SerialFlash_WriteEnable();

 CopyImageToSerialFlash(red_square_bmp, 3206, 1);
 TFT_Set_Ext_Buffer(FlashReadHandler);



 TFT_Ext_Image(200, 150, 0x00000000, 1);
}
