_SerialFlashUtilInit:
;Serial_Flash_Util.c,20 :: 		void SerialFlashUtilInit()
;Serial_Flash_Util.c,22 :: 		g_row = 5; // y axis
MOVS	R1, #5
MOVW	R0, #lo_addr(Serial_Flash_Util_g_row+0)
MOVT	R0, #hi_addr(Serial_Flash_Util_g_row+0)
STRH	R1, [R0, #0]
;Serial_Flash_Util.c,23 :: 		g_col = 5; // x axis
MOVS	R1, #5
MOVW	R0, #lo_addr(Serial_Flash_Util_g_col+0)
MOVT	R0, #hi_addr(Serial_Flash_Util_g_col+0)
STRH	R1, [R0, #0]
;Serial_Flash_Util.c,25 :: 		}
L_end_SerialFlashUtilInit:
BX	LR
; end of _SerialFlashUtilInit
_CopyImageToSerialFlash:
;Serial_Flash_Util.c,31 :: 		unsigned long CopyImageToSerialFlash(const code char *image, unsigned int image_length, char erase_chip)
; erase_chip start address is: 8 (R2)
SUB	SP, SP, #36
STR	LR, [SP, #0]
;Serial_Flash_Util.c,33 :: 		unsigned long flash_addr = 0x0000; // start address of flash memory
STR	R0, [SP, #20]
UXTB	R0, R2
STRH	R1, [SP, #24]
; erase_chip end address is: 8 (R2)
; erase_chip start address is: 0 (R0)
MOV	R3, #0
STR	R3, [SP, #16]
;Serial_Flash_Util.c,34 :: 		unsigned long image_flash_address = flash_addr;
LDR	R3, [SP, #16]
STR	R3, [SP, #8]
;Serial_Flash_Util.c,35 :: 		unsigned int i = 0;
;Serial_Flash_Util.c,36 :: 		char* image_ptr = image;
LDR	R3, [SP, #20]
STR	R3, [SP, #12]
;Serial_Flash_Util.c,38 :: 		if (image == 0) { return 0; }
LDR	R3, [SP, #20]
CMP	R3, #0
IT	NE
BNE	L_CopyImageToSerialFlash0
; erase_chip end address is: 0 (R0)
MOVS	R0, #0
IT	AL
BAL	L_end_CopyImageToSerialFlash
L_CopyImageToSerialFlash0:
;Serial_Flash_Util.c,40 :: 		if (erase_chip == 1)
; erase_chip start address is: 0 (R0)
CMP	R0, #1
IT	NE
BNE	L_CopyImageToSerialFlash1
; erase_chip end address is: 0 (R0)
;Serial_Flash_Util.c,42 :: 		TFT_Write_Text("Erasing chip... ", g_col, g_row+=g_incr);
MOVW	R3, #lo_addr(Serial_Flash_Util_g_incr+0)
MOVT	R3, #hi_addr(Serial_Flash_Util_g_incr+0)
LDRH	R5, [R3, #0]
MOVW	R4, #lo_addr(Serial_Flash_Util_g_row+0)
MOVT	R4, #hi_addr(Serial_Flash_Util_g_row+0)
LDRH	R3, [R4, #0]
ADDS	R3, R3, R5
STRH	R3, [R4, #0]
UXTH	R5, R3
MOVW	R3, #lo_addr(Serial_Flash_Util_g_col+0)
MOVT	R3, #hi_addr(Serial_Flash_Util_g_col+0)
STR	R3, [SP, #32]
LDRH	R4, [R3, #0]
MOVW	R3, #lo_addr(?lstr1_Serial_Flash_Util+0)
MOVT	R3, #hi_addr(?lstr1_Serial_Flash_Util+0)
UXTH	R2, R5
UXTH	R1, R4
MOV	R0, R3
BL	_TFT_Write_Text+0
;Serial_Flash_Util.c,43 :: 		SerialFlash_ChipErase();
BL	_SerialFlash_ChipErase+0
;Serial_Flash_Util.c,44 :: 		TFT_Write_Text("Done", g_col, g_row+=g_incr);
MOVW	R3, #lo_addr(Serial_Flash_Util_g_incr+0)
MOVT	R3, #hi_addr(Serial_Flash_Util_g_incr+0)
LDRH	R5, [R3, #0]
MOVW	R4, #lo_addr(Serial_Flash_Util_g_row+0)
MOVT	R4, #hi_addr(Serial_Flash_Util_g_row+0)
LDRH	R3, [R4, #0]
ADDS	R3, R3, R5
STRH	R3, [R4, #0]
UXTH	R5, R3
LDR	R3, [SP, #32]
LDRH	R4, [R3, #0]
MOVW	R3, #lo_addr(?lstr2_Serial_Flash_Util+0)
MOVT	R3, #hi_addr(?lstr2_Serial_Flash_Util+0)
UXTH	R2, R5
UXTH	R1, R4
MOV	R0, R3
BL	_TFT_Write_Text+0
;Serial_Flash_Util.c,45 :: 		}
L_CopyImageToSerialFlash1:
;Serial_Flash_Util.c,47 :: 		TFT_Write_Text("Copying image to serial flash...", g_col, g_row+=g_incr);
MOVW	R3, #lo_addr(Serial_Flash_Util_g_incr+0)
MOVT	R3, #hi_addr(Serial_Flash_Util_g_incr+0)
LDRH	R5, [R3, #0]
MOVW	R4, #lo_addr(Serial_Flash_Util_g_row+0)
MOVT	R4, #hi_addr(Serial_Flash_Util_g_row+0)
LDRH	R3, [R4, #0]
ADDS	R3, R3, R5
STRH	R3, [R4, #0]
UXTH	R5, R3
MOVW	R3, #lo_addr(Serial_Flash_Util_g_col+0)
MOVT	R3, #hi_addr(Serial_Flash_Util_g_col+0)
LDRH	R4, [R3, #0]
MOVW	R3, #lo_addr(?lstr3_Serial_Flash_Util+0)
MOVT	R3, #hi_addr(?lstr3_Serial_Flash_Util+0)
UXTH	R2, R5
UXTH	R1, R4
MOV	R0, R3
BL	_TFT_Write_Text+0
;Serial_Flash_Util.c,48 :: 		for (i = 0; i < image_length; i++)
; i start address is: 16 (R4)
MOVS	R4, #0
; i end address is: 16 (R4)
UXTH	R0, R4
L_CopyImageToSerialFlash2:
; i start address is: 0 (R0)
LDRH	R3, [SP, #24]
CMP	R0, R3
IT	CS
BCS	L_CopyImageToSerialFlash3
;Serial_Flash_Util.c,52 :: 		SerialFlash_WriteByte(*image_ptr, flash_addr);
LDR	R3, [SP, #12]
LDRB	R3, [R3, #0]
STRH	R0, [SP, #4]
LDR	R1, [SP, #16]
UXTB	R0, R3
BL	_SerialFlash_WriteByte+0
LDRH	R0, [SP, #4]
;Serial_Flash_Util.c,53 :: 		image_ptr++;
LDR	R3, [SP, #12]
ADDS	R3, R3, #1
STR	R3, [SP, #12]
;Serial_Flash_Util.c,54 :: 		flash_addr++;
LDR	R3, [SP, #16]
ADDS	R3, R3, #1
STR	R3, [SP, #16]
;Serial_Flash_Util.c,48 :: 		for (i = 0; i < image_length; i++)
ADDS	R4, R0, #1
UXTH	R4, R4
; i end address is: 0 (R0)
; i start address is: 16 (R4)
;Serial_Flash_Util.c,55 :: 		}
UXTH	R0, R4
; i end address is: 16 (R4)
IT	AL
BAL	L_CopyImageToSerialFlash2
L_CopyImageToSerialFlash3:
;Serial_Flash_Util.c,56 :: 		TFT_Write_Text("Done", g_col, g_row+=g_incr);
MOVW	R3, #lo_addr(Serial_Flash_Util_g_incr+0)
MOVT	R3, #hi_addr(Serial_Flash_Util_g_incr+0)
LDRH	R5, [R3, #0]
MOVW	R4, #lo_addr(Serial_Flash_Util_g_row+0)
MOVT	R4, #hi_addr(Serial_Flash_Util_g_row+0)
LDRH	R3, [R4, #0]
ADDS	R3, R3, R5
STRH	R3, [R4, #0]
UXTH	R5, R3
MOVW	R3, #lo_addr(Serial_Flash_Util_g_col+0)
MOVT	R3, #hi_addr(Serial_Flash_Util_g_col+0)
STR	R3, [SP, #32]
LDRH	R4, [R3, #0]
MOVW	R3, #lo_addr(?lstr4_Serial_Flash_Util+0)
MOVT	R3, #hi_addr(?lstr4_Serial_Flash_Util+0)
UXTH	R2, R5
UXTH	R1, R4
MOV	R0, R3
BL	_TFT_Write_Text+0
;Serial_Flash_Util.c,59 :: 		TFT_Write_Text("Verifying...", g_col, g_row+=g_incr);
MOVW	R3, #lo_addr(Serial_Flash_Util_g_incr+0)
MOVT	R3, #hi_addr(Serial_Flash_Util_g_incr+0)
LDRH	R5, [R3, #0]
MOVW	R4, #lo_addr(Serial_Flash_Util_g_row+0)
MOVT	R4, #hi_addr(Serial_Flash_Util_g_row+0)
LDRH	R3, [R4, #0]
ADDS	R3, R3, R5
STRH	R3, [R4, #0]
UXTH	R5, R3
LDR	R3, [SP, #32]
LDRH	R4, [R3, #0]
MOVW	R3, #lo_addr(?lstr5_Serial_Flash_Util+0)
MOVT	R3, #hi_addr(?lstr5_Serial_Flash_Util+0)
UXTH	R2, R5
UXTH	R1, R4
MOV	R0, R3
BL	_TFT_Write_Text+0
;Serial_Flash_Util.c,60 :: 		image_ptr = image;
LDR	R3, [SP, #20]
STR	R3, [SP, #12]
;Serial_Flash_Util.c,61 :: 		flash_addr = 0x0000;
MOVS	R3, #0
STR	R3, [SP, #16]
;Serial_Flash_Util.c,62 :: 		for (i = 0; i < image_length; i++)
; i start address is: 16 (R4)
MOVS	R4, #0
; i end address is: 16 (R4)
UXTH	R1, R4
L_CopyImageToSerialFlash5:
; i start address is: 4 (R1)
LDRH	R3, [SP, #24]
CMP	R1, R3
IT	CS
BCS	L_CopyImageToSerialFlash6
;Serial_Flash_Util.c,64 :: 		if (*image_ptr != SerialFlash_ReadByte(flash_addr))
LDR	R3, [SP, #12]
LDRB	R3, [R3, #0]
STRB	R3, [SP, #32]
STRH	R1, [SP, #4]
LDR	R0, [SP, #16]
BL	_SerialFlash_ReadByte+0
LDRH	R1, [SP, #4]
LDRB	R3, [SP, #32]
CMP	R3, R0
IT	EQ
BEQ	L_CopyImageToSerialFlash8
; i end address is: 4 (R1)
;Serial_Flash_Util.c,66 :: 		TFT_Write_Text("ERROR", g_col, g_row+=g_incr);
MOVW	R3, #lo_addr(Serial_Flash_Util_g_incr+0)
MOVT	R3, #hi_addr(Serial_Flash_Util_g_incr+0)
LDRH	R5, [R3, #0]
MOVW	R4, #lo_addr(Serial_Flash_Util_g_row+0)
MOVT	R4, #hi_addr(Serial_Flash_Util_g_row+0)
LDRH	R3, [R4, #0]
ADDS	R3, R3, R5
STRH	R3, [R4, #0]
UXTH	R5, R3
MOVW	R3, #lo_addr(Serial_Flash_Util_g_col+0)
MOVT	R3, #hi_addr(Serial_Flash_Util_g_col+0)
LDRH	R4, [R3, #0]
MOVW	R3, #lo_addr(?lstr6_Serial_Flash_Util+0)
MOVT	R3, #hi_addr(?lstr6_Serial_Flash_Util+0)
UXTH	R2, R5
UXTH	R1, R4
MOV	R0, R3
BL	_TFT_Write_Text+0
;Serial_Flash_Util.c,67 :: 		return 0;
MOVS	R0, #0
IT	AL
BAL	L_end_CopyImageToSerialFlash
;Serial_Flash_Util.c,68 :: 		}
L_CopyImageToSerialFlash8:
;Serial_Flash_Util.c,69 :: 		image_ptr++;
; i start address is: 4 (R1)
LDR	R3, [SP, #12]
ADDS	R3, R3, #1
STR	R3, [SP, #12]
;Serial_Flash_Util.c,70 :: 		flash_addr++;
LDR	R3, [SP, #16]
ADDS	R3, R3, #1
STR	R3, [SP, #16]
;Serial_Flash_Util.c,62 :: 		for (i = 0; i < image_length; i++)
ADDS	R3, R1, #1
; i end address is: 4 (R1)
; i start address is: 16 (R4)
UXTH	R4, R3
;Serial_Flash_Util.c,71 :: 		}
UXTH	R1, R4
; i end address is: 16 (R4)
IT	AL
BAL	L_CopyImageToSerialFlash5
L_CopyImageToSerialFlash6:
;Serial_Flash_Util.c,72 :: 		TFT_Write_Text("Done", g_col, g_row+=g_incr);
MOVW	R3, #lo_addr(Serial_Flash_Util_g_incr+0)
MOVT	R3, #hi_addr(Serial_Flash_Util_g_incr+0)
LDRH	R5, [R3, #0]
MOVW	R4, #lo_addr(Serial_Flash_Util_g_row+0)
MOVT	R4, #hi_addr(Serial_Flash_Util_g_row+0)
LDRH	R3, [R4, #0]
ADDS	R3, R3, R5
STRH	R3, [R4, #0]
UXTH	R5, R3
MOVW	R3, #lo_addr(Serial_Flash_Util_g_col+0)
MOVT	R3, #hi_addr(Serial_Flash_Util_g_col+0)
LDRH	R4, [R3, #0]
MOVW	R3, #lo_addr(?lstr7_Serial_Flash_Util+0)
MOVT	R3, #hi_addr(?lstr7_Serial_Flash_Util+0)
UXTH	R2, R5
UXTH	R1, R4
MOV	R0, R3
BL	_TFT_Write_Text+0
;Serial_Flash_Util.c,74 :: 		return image_flash_address;
LDR	R0, [SP, #8]
;Serial_Flash_Util.c,75 :: 		}
L_end_CopyImageToSerialFlash:
LDR	LR, [SP, #0]
ADD	SP, SP, #36
BX	LR
; end of _CopyImageToSerialFlash
_FlashReadHandler:
;Serial_Flash_Util.c,80 :: 		char* FlashReadHandler(unsigned long offset, unsigned long count, unsigned long* num)
SUB	SP, SP, #16
STR	LR, [SP, #0]
;Serial_Flash_Util.c,84 :: 		int i = 0;
STR	R0, [SP, #4]
STR	R1, [SP, #8]
STR	R2, [SP, #12]
;Serial_Flash_Util.c,86 :: 		if (count > BUFFER_SERIAL_LEN) Soft_UART_WriteText("error: buffer overflow");
LDR	R3, [SP, #8]
CMP	R3, #512
IT	LS
BLS	L_FlashReadHandler9
MOVW	R3, #lo_addr(?lstr8_Serial_Flash_Util+0)
MOVT	R3, #hi_addr(?lstr8_Serial_Flash_Util+0)
MOV	R0, R3
BL	_Soft_UART_WriteText+0
L_FlashReadHandler9:
;Serial_Flash_Util.c,101 :: 		memset(serial_buffer, 0, BUFFER_SERIAL_LEN);
MOVW	R2, #512
SXTH	R2, R2
MOVS	R1, #0
MOVW	R0, #lo_addr(Serial_Flash_Util_serial_buffer+0)
MOVT	R0, #hi_addr(Serial_Flash_Util_serial_buffer+0)
BL	_memset+0
;Serial_Flash_Util.c,102 :: 		SerialFlash_ReadArray(offset, serial_buffer, count);
LDR	R2, [SP, #8]
MOVW	R1, #lo_addr(Serial_Flash_Util_serial_buffer+0)
MOVT	R1, #hi_addr(Serial_Flash_Util_serial_buffer+0)
LDR	R0, [SP, #4]
BL	_SerialFlash_ReadArray+0
;Serial_Flash_Util.c,103 :: 		*num = count;
LDR	R4, [SP, #8]
LDR	R3, [SP, #12]
STR	R4, [R3, #0]
;Serial_Flash_Util.c,111 :: 		return serial_buffer;
MOVW	R0, #lo_addr(Serial_Flash_Util_serial_buffer+0)
MOVT	R0, #hi_addr(Serial_Flash_Util_serial_buffer+0)
;Serial_Flash_Util.c,112 :: 		}
L_end_FlashReadHandler:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _FlashReadHandler
