#include "Soft_UART_Helper.h"

/*
* Include Software_UART library
*/

void Init_Soft_UART()
{
   Soft_UART_Init(&GPIO_PORTA, 0, 1, 9600, 0);
   Soft_UART_WriteText("Soft UART is alive.\n");
}

void Soft_UART_WriteText(char *string)
{
   char *loc_string;

   if (string == 0)
      return;

   loc_string = string;
   while (*loc_string != '\0')
   {
      Soft_UART_Write(*loc_string);
      loc_string++;
   }

   Soft_UART_Write('\n');
   Soft_UART_Write('\r');
   return;
}
