_Init_Soft_UART:
;Soft_UART_Helper.c,7 :: 		void Init_Soft_UART()
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Soft_UART_Helper.c,9 :: 		Soft_UART_Init(&GPIO_PORTA, 0, 1, 9600, 0);
MOVS	R0, #0
PUSH	(R0)
MOVW	R3, #9600
MOVS	R2, #1
MOVS	R1, #0
MOVW	R0, #lo_addr(GPIO_PORTA+0)
MOVT	R0, #hi_addr(GPIO_PORTA+0)
BL	_Soft_UART_Init+0
ADD	SP, SP, #4
;Soft_UART_Helper.c,10 :: 		Soft_UART_WriteText("Soft UART is alive.\n");
MOVW	R0, #lo_addr(?lstr1_Soft_UART_Helper+0)
MOVT	R0, #hi_addr(?lstr1_Soft_UART_Helper+0)
BL	_Soft_UART_WriteText+0
;Soft_UART_Helper.c,11 :: 		}
L_end_Init_Soft_UART:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Init_Soft_UART
_Soft_UART_WriteText:
;Soft_UART_Helper.c,13 :: 		void Soft_UART_WriteText(char *string)
; string start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Soft_UART_Helper.c,17 :: 		if (string == 0)
; string end address is: 0 (R0)
; string start address is: 0 (R0)
CMP	R0, #0
IT	NE
BNE	L_Soft_UART_WriteText0
; string end address is: 0 (R0)
;Soft_UART_Helper.c,18 :: 		return;
IT	AL
BAL	L_end_Soft_UART_WriteText
L_Soft_UART_WriteText0:
;Soft_UART_Helper.c,20 :: 		loc_string = string;
; loc_string start address is: 4 (R1)
; string start address is: 0 (R0)
MOV	R1, R0
; string end address is: 0 (R0)
; loc_string end address is: 4 (R1)
MOV	R6, R1
;Soft_UART_Helper.c,21 :: 		while (*loc_string != '\0')
L_Soft_UART_WriteText1:
; loc_string start address is: 24 (R6)
LDRB	R1, [R6, #0]
CMP	R1, #0
IT	EQ
BEQ	L_Soft_UART_WriteText2
;Soft_UART_Helper.c,23 :: 		Soft_UART_Write(*loc_string);
LDRB	R1, [R6, #0]
UXTB	R0, R1
BL	_Soft_UART_Write+0
;Soft_UART_Helper.c,24 :: 		loc_string++;
ADDS	R6, R6, #1
;Soft_UART_Helper.c,25 :: 		}
; loc_string end address is: 24 (R6)
IT	AL
BAL	L_Soft_UART_WriteText1
L_Soft_UART_WriteText2:
;Soft_UART_Helper.c,27 :: 		Soft_UART_Write('\n');
MOVS	R0, #10
BL	_Soft_UART_Write+0
;Soft_UART_Helper.c,28 :: 		Soft_UART_Write('\r');
MOVS	R0, #13
BL	_Soft_UART_Write+0
;Soft_UART_Helper.c,29 :: 		return;
;Soft_UART_Helper.c,30 :: 		}
L_end_Soft_UART_WriteText:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Soft_UART_WriteText
